#!/usr/bin/env python
import os
import sys
    
#add lib path
playbook_file = os.path.realpath(sys.argv[0])
playbook_path=os.path.split(playbook_file)[0]   

lib_path=os.path.join(playbook_path,'library')
if os.path.exists(lib_path) is True:
    sys.path.insert(0,lib_path)
    lib_path=os.path.join(lib_path,'securecat')
    if os.path.exists(lib_path) is True:
        sys.path.insert(0,lib_path)
        modulepath = os.environ.get('CSC_MODULE_PATH')
        if modulepath is None:
            os.environ['CSC_MODULE_PATH'] = lib_path
    
from utils import playbook


class MyPlaybook(playbook.Playbook):
    
    def set_extra_vars_pre(self):
        pass
    
    def set_extra_vars_post(self):
        pass
    
    def get_tasks(self, dir):
        ret = []        
        ret.append([dir, 't_1.py'])
        ret.append([dir, 't_1_2.py'])
        ret.append([dir, 't_1_2_1.py'])
        ret.append([dir, 't_1_2_2.py'])
        ret.append([dir, 't_2.py'])
        ret.append([dir, 't_2_1.py'])
        ret.append([dir, 't_2_1_1.py'])
        ret.append([dir, 't_2_1_2.py'])
        ret.append([dir, 't_2_1_3.py'])
        ret.append([dir, 't_2_1_4.py'])
        ret.append([dir, 't_2_1_5.py'])
        ret.append([dir, 't_2_1_6.py'])
        ret.append([dir, 't_2_1_7.py'])
        ret.append([dir, 't_2_1_8.py'])
        ret.append([dir, 't_2_1_9.py'])
        ret.append([dir, 't_2_1_10.py'])
        ret.append([dir, 't_2_1_11.py'])
        ret.append([dir, 't_2_1_12.py'])
        ret.append([dir, 't_2_1_13.py'])
        ret.append([dir, 't_2_1_14.py'])
        ret.append([dir, 't_2_1_15.py'])
        ret.append([dir, 't_2_1_16.py'])
        ret.append([dir, 't_2_1_17.py'])
        ret.append([dir, 't_2_1_18.py'])
        ret.append([dir, 't_2_1_19.py'])
        ret.append([dir, 't_2_1_20.py'])
        ret.append([dir, 't_2_2.py'])
        ret.append([dir, 't_2_2_9.py'])
        ret.append([dir, 't_2_2_12.py'])
        ret.append([dir, 't_2_2_14.py'])
        ret.append([dir, 't_2_2_16.py'])
        ret.append([dir, 't_2_2_17.py'])
        ret.append([dir, 't_2_2_18.py'])
        ret.append([dir, 't_2_2_20.py'])
        ret.append([dir, 't_2_3_4.py'])
        ret.append([dir, 't_2_3_5.py'])
        ret.append([dir, 't_2_3_6.py'])
        ret.append([dir, 't_2_3_7.py'])
        ret.append([dir, 't_2_3_10.py'])
        ret.append([dir, 't_2_3_11.py'])
        ret.append([dir, 't_2_3_12.py'])
        ret.append([dir, 't_2_3_13.py'])
        ret.append([dir, 't_2_3_16.py'])
        ret.append([dir, 't_2_3_17_1.py'])
        ret.append([dir, 't_2_3_17_1_1.py'])
        ret.append([dir, 't_2_3_17_1_2.py'])
        ret.append([dir, 't_2_3_17_2_1.py'])
        ret.append([dir, 't_2_3_17_2_1_1.py'])
        ret.append([dir, 't_2_3_17_2_1_12.py'])
        ret.append([dir, 't_2_3_17_2_1_13.py'])
        ret.append([dir, 't_2_3_17_2_1_14.py'])
        ret.append([dir, 't_2_3_17_2_1_15.py'])
        ret.append([dir, 't_2_3_17_2_1_16.py'])
        ret.append([dir, 't_2_3_17_2_1_2.py'])
        ret.append([dir, 't_2_3_17_2_1_3.py'])
        ret.append([dir, 't_2_3_17_2_1_4.py'])
        ret.append([dir, 't_2_3_17_2_1_5.py'])
        ret.append([dir, 't_2_3_17_2_2.py'])
        ret.append([dir, 't_2_3_17_2_2_1.py'])
        ret.append([dir, 't_2_3_17_2_3.py'])
        ret.append([dir, 't_2_3_17_2_3_1.py'])
        ret.append([dir, 't_2_4.py'])
        ret.append([dir, 't_2_4_2.py'])
        ret.append([dir, 't_2_4_3.py'])
        ret.append([dir, 't_2_4_4.py'])
        ret.append([dir, 't_2_4_5.py'])
        ret.append([dir, 't_2_4_6.py'])
        ret.append([dir, 't_2_4_7.py'])
        ret.append([dir, 't_2_4_8.py'])
        ret.append([dir, 't_2_4_9.py'])
        ret.append([dir, 't_2_4_10.py'])
        ret.append([dir, 't_2_4_11.py'])
        ret.append([dir, 't_2_4_12.py'])
        ret.append([dir, 't_2_4_13.py'])
        ret.append([dir, 't_2_4_14.py'])
        ret.append([dir, 't_2_4_15.py'])
        ret.append([dir, 't_2_4_16.py'])
        ret.append([dir, 't_2_5.py'])
        ret.append([dir, 't_2_5_1.py'])
        ret.append([dir, 't_2_6.py'])
        #ret.append([dir, 't_2_6_1.py'])
        ret.append([dir, 't_3.py'])
        ret.append([dir, 't_3_1.py'])
        ret.append([dir, 't_3_1_1.py'])
        ret.append([dir, 't_3_1_2.py'])
        ret.append([dir, 't_3_1_3.py'])
        ret.append([dir, 't_3_1_5.py'])
        ret.append([dir, 't_3_1_7.py'])
        ret.append([dir, 't_3_1_8.py'])
        ret.append([dir, 't_3_1_9.py'])
        ret.append([dir, 't_3_2.py'])
        ret.append([dir, 't_3_2_1.py'])
        ret.append([dir, 't_3_2_2.py'])
        ret.append([dir, 't_3_2_3.py'])
        ret.append([dir, 't_3_2_5.py'])
        return ret
    
if __name__ == '__main__':
    
    myplaybook = MyPlaybook()
    myplaybook.set_role('hw')
    myplaybook.run()
    

