﻿# -*- coding: UTF-8 -*-
import json
import os


def get_tags():
    return ['1', '1.2', '1.2.1']

    
def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext, ansible_params, module)
    return rc,out
    
    
def run_audit(runcontext, ansible_params, module):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    
    tmp_vars["systemvalue1"] = ""
    ret_code = -1
    ret_info = []
    ret_logic = []
    check_list = ["openldap2", "openldap2-client", "biosdevname", "telnet-server", "rsh-server", "ypserv", "tftp", "tftp-server", "talk-server", "xinetd", "xorg-x11-server-common", "dhcp", "openldap-servers", "openldap-clients", "bind", "vsftpd", "httpd", "dovecot", "samba", "squid", "net-snmp"]
    
    for check in check_list:
        tmp_vars["scancommand1"] = '''rpm -q {0};echo $?'''.format(check)
        runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
        arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
        runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
        runcontext.sleep()
        
        if arc1 == -1:
            return (-2, "Failed to invoke module: %s." % astdout1)
        resultjson1 = json.loads(astdout1)
        astdout1 = resultjson1["stdout"]
        astderr1 = resultjson1["stderr"]
        
        list_out = astdout1.splitlines()
        arc1 = int(list_out.pop())
        astdout1 = os.linesep.join(list_out)
        
        if arc1 == 1:
            ret_logic.append(True)
        else:
            ret_logic.append(False)
            ret_info.append(astdout1)
            
    tmp_vars["systemvalue1"] = "\n".join(ret_info)
    if False not in ret_logic:
        ret_code = 0
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = ""
        
    rc, out = curtemplate.render(runcontext.get_template_file('t_1_2_1.j2'), **tmp_vars)
    
    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code, out
