﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.1','2.1.8']

def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out
def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = "systemctl is-enabled rexec.socket 2>&1"
    tmp_vars["systemvalue1"] = ""
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = "systemctl is-enabled rlogin.socket 2>&1"
    tmp_vars["systemvalue2"] = ""
    tmp_vars["checkresult3"] = "failed"
    tmp_vars["scancommand3"] = "systemctl is-enabled rsh.socket 2>&1"
    tmp_vars["systemvalue3"] = ""
    tmp_vars["checkresult4"] = "failed"
    tmp_vars["scancommand4"] = "rpm -q rsh"
    tmp_vars["systemvalue4"] = ""
    ret_code = 0
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
    arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc2,astdout2,astderr2)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand3"])
    arc3,astdout3,astderr3=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc3,astdout3,astderr3)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand4"])
    arc4,astdout4,astderr4=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc4,astdout4,astderr4)
    runcontext.sleep()
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    match1_found=re.match(r"(Failed\s+to\s+get\s+unit\s+file\s+state\s+for\s+rexec\.socket:\s+No\s+such\s+file\s+or\s+directory)|(disabled)",astdout1)
    if match1_found == None:
        tmp_vars["systemvalue1"] = astdout1
    else:
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = astdout1
    if arc2 != 0:
        return (-2, "Failed to invoke module: %s."%astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    astderr2 = resultjson2["stderr"]
    match2_found=re.match(r"(Failed\s+to\s+get\s+unit\s+file\s+state\s+for\s+rlogin\.socket:\s+No\s+such\s+file\s+or\s+directory)|(disabled)",astdout2)
    if match2_found == None:
        tmp_vars["systemvalue2"] = astdout2
    else:
        tmp_vars["checkresult2"] = "pass"
        tmp_vars["systemvalue2"] = astdout2
    if arc3 != 0:
        return (-2, "Failed to invoke module: %s."%astdout3)
    resultjson3 = json.loads(astdout3)
    astdout3 = resultjson3["stdout"]
    astderr3 = resultjson3["stderr"]
    match3_found=re.match(r"(Failed\s+to\s+get\s+unit\s+file\s+state\s+for\s+rsh\.socket:\s+No\s+such\s+file\s+or\s+directory)|(disabled)",astdout3)
    if match3_found == None:
        tmp_vars["systemvalue3"] = astdout3
    else:
        tmp_vars["checkresult3"] = "pass"
        tmp_vars["systemvalue3"] = astdout3
    if arc4 != 0:
        return (-2, "Failed to invoke module: %s."%astdout4)
    resultjson4 = json.loads(astdout4)
    astdout4 = resultjson4["stdout"]
    astderr4 = resultjson4["stderr"]
    match4_found=re.match(r"package\s+rsh\s+is\s+not\s+installed||.+rsh\s*$",astdout4)
    if match4_found == None:
        tmp_vars["systemvalue4"] = astdout4
    else:
        tmp_vars["checkresult4"] = "pass"
        tmp_vars["systemvalue4"] = astdout4
    if tmp_vars["checkresult1"]=="pass" and tmp_vars["checkresult2"]=="pass" and tmp_vars["checkresult3"]=="pass" and tmp_vars["checkresult4"] == "pass":
        tmp_vars["policyresult"]="pass"
        ret_code = 0
    else:
        ret_code = -1
    rc,out=curtemplate.render(runcontext.get_template_file('t_2_1_8.j2'),**tmp_vars)
    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
