﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.2','2.2.20']

def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out
def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = "modprobe -n -v jffs2 2>&1;modprobe -n -v hfs 2>&1;modprobe -n -v hfsplus 2>&1;modprobe -n -v squashfs 2>&1;modprobe -n -v udf 2>&1;modprobe -n -v vfat 2>&1;modprobe -n -v freevxfs 2>&1;modprobe -n -v cramfs 2>&1"
    tmp_vars["systemvalue1"] = ""
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = "lsmod | grep jffs2 2>&1;lsmod | grep hfs 2>&1;lsmod | grep hfsplus 2>&1;lsmod | grep squashfs 2>&1;lsmod | grep udf 2>&1;lsmod | grep vfat 2>&1;lsmod | grep freevxfs 2>&1;lsmod | grep cramfs 2>&1"
    tmp_vars["systemvalue2"] = ""
    ret_code = 0
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
    arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc2,astdout2,astderr2)
    runcontext.sleep()
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    multiLine = astdout1.splitlines()
    match1_found = True
    for line in multiLine:
        if re.match(r'.*not found\s*$|\s*install\s+/bin/true\s*|.*/kernel/drivers/.*|.*/kernel/lib/.*', ''.join(line)) is None:
            match1_found = False
    if match1_found == False:
        tmp_vars["systemvalue1"] = astdout1
    else:
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = astdout1
    if arc2 != 0:
        return (-2, "Failed to invoke module: %s."%astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    astderr2 = resultjson2["stderr"]
    match2_found=re.match("^$",astdout2)
    if match2_found is None:
        tmp_vars["systemvalue2"] = astdout2
    else:
        tmp_vars["checkresult2"] = "pass"
        tmp_vars["systemvalue2"] = astdout2
    
    
    if tmp_vars["checkresult1"]=="pass" and tmp_vars["checkresult2"]=="pass":
        tmp_vars["policyresult"]="pass"
        ret_code = 0
    else:
        ret_code = -1
    rc,out=curtemplate.render(runcontext.get_template_file('t_2_2_20.j2'),**tmp_vars)
    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
