﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.3','2.3.10']

def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out
def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = '''days=$(grep "[[:space:]]*PASS_MAX_DAYS[[:space:]]*" /etc/login.defs | grep -v "^[[:space:]]*#" | awk '{print $2}');if [ "$days" -gt 90 -o "$days" -lt 0 ];then echo PASS_MAX_DAYS $days;else echo "PASS_MAX_DAYS $days ";fi'''
    tmp_vars["systemvalue1"] = ""
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = '''days=$(grep "[[:space:]]*PASS_MIN_DAYS[[:space:]]*" /etc/login.defs | grep -v "^[[:space:]]*#" | awk '{print $2}');if [ "$days" -lt 7 ];then echo PASS_MIN_DAYS $days;else echo "PASS_MIN_DAYS $days ";fi'''
    tmp_vars["systemvalue2"] = ""
    tmp_vars["checkresult3"] = "failed"
    tmp_vars["scancommand3"] = '''days=$(grep "[[:space:]]*PASS_WARN_AGE[[:space:]]*" /etc/login.defs | grep -v "^[[:space:]]*#" | awk '{print $2}');if [ "$days" -lt 30 ];then echo PASS_WARN_AGE $days;else echo "PASS_WARN_AGE $days ";fi'''
    tmp_vars["systemvalue3"] = ""
    ret_code = 0
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
    arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc2,astdout2,astderr2)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand3"])
    arc3,astdout3,astderr3=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc3,astdout3,astderr3)
    runcontext.sleep()
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    match1_found=re.match(r"\s*PASS_MAX_DAYS\s*\d+\s+$",astdout1)
    if match1_found == None:  
        tmp_vars["systemvalue1"] = astdout1
    else:
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = astdout1
    if arc2 != 0:
        return (-2, "Failed to invoke module: %s."%astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    astderr2 = resultjson2["stderr"]
    match2_found=re.match(r"^\s*PASS_MIN_DAYS\s*\d+\s+$",astdout2)
    if match2_found == None:
        tmp_vars["systemvalue2"] = astdout2
    else:
        tmp_vars["checkresult2"] = "pass"
        tmp_vars["systemvalue2"] = astdout2
    if arc3 != 0:
        return (-2, "Failed to invoke module: %s."%astdout3)
    resultjson3 = json.loads(astdout3)
    astdout3 = resultjson3["stdout"]
    astderr3 = resultjson3["stderr"]
    match3_found=re.match(r"^\s*PASS_WARN_AGE\s*\d+\s+$",astdout3)
    if match3_found == None:
        tmp_vars["systemvalue3"] = astdout3
    else:
        tmp_vars["checkresult3"] = "pass"
        tmp_vars["systemvalue3"] = astdout3
    if tmp_vars["checkresult1"]=="pass" and tmp_vars["checkresult2"]=="pass" and tmp_vars["checkresult3"]=="pass":
        tmp_vars["policyresult"]="pass"
        ret_code = 0
    else:
        ret_code = -1
    rc,out=curtemplate.render(runcontext.get_template_file('t_2_3_10.j2'),**tmp_vars)
    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
