﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.3','2.3.17','2.3.17.2','2.3.17.2.1','2.3.17.2.1.12']

def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out
def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = "grep -v \"^\\s*#\" /etc/sudoers | awk -F'#' '{print $1}' | grep -E \"^\\s*Defaults\\s+passwd_tries\""
    tmp_vars["systemvalue1"] = ""
    ret_code = 0
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
    runcontext.sleep()
    
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
        
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    
    if astdout1 == "" and astderr1 == "":
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = astdout1
    else:    
        match1_found=re.match(r"^\s*Defaults\s+passwd_tries\s*=\s*[1-3]\s*$|^$",astdout1)
        if match1_found == None:
            tmp_vars["systemvalue1"] = astdout1
        else:
            tmp_vars["checkresult1"] = "pass"
            tmp_vars["systemvalue1"] = astdout1
        
    if tmp_vars["checkresult1"] == "pass":
        tmp_vars["policyresult"]="pass"
        ret_code = 0
    else:
        ret_code = -1
        
    rc,out=curtemplate.render(runcontext.get_template_file('t_2_3_17_2_1_12.j2'),**tmp_vars)
    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
