﻿# -*- coding: UTF-8 -*-
import json

def get_tags():
    return ['2','2.3','2.3.17','2.3.17.2','2.3.17.2.1','2.3.17.2.1.16']

def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out
def run_audit(runcontext,ansible_params,module):
    retCheckMsg = []
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = r'''cat /etc/sudoers | grep -v "^\s*#" | grep -E "^\s*Defaults[[:space:]]+\![[:space:]]*syslog"'''
    tmp_vars["scancommand2"] = r'''cat /etc/sudoers | grep -v "^\s*#" | grep -E "^\s*Defaults[[:space:]]+\![[:space:]]*logfile"'''
    tmp_vars["systemvalue1"] = ""
    ret_code = -1
    
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    retCheckMsg.append(astdout1)

    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
    arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc2,astdout2,astderr2)
    runcontext.sleep()
    if arc2 != 0:
        return (-2, "Failed to invoke module: %s."%astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    retCheckMsg.append(astdout2)
    
    tmp_vars["systemvalue1"] = ' '.join(retCheckMsg)
    if astdout1 == '' or astdout2 == '':
        ret_code = 0
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["policyresult"] = "pass"

        
    rc,out=curtemplate.render(runcontext.get_template_file('t_2_3_17_2_1_16.j2'),**tmp_vars)
    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
