﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.3','2.3.5']

def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out
def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = '''a=$(stat -L --format="%U:%G" /etc/motd 2>/dev/null);b=$(stat -L --format="%a" /etc/motd 2>/dev/null);if [ "$a" == "root:root" ];then printf "/etc/motd $a";else printf "/etc/motd $a";fi;if (( (0$b&0133)!=0 ));then printf " $b";else printf " $b";fi'''
    tmp_vars["systemvalue1"] = ""
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = '''a=$(stat -L --format="%U:%G" /etc/issue 2>/dev/null);b=$(stat -L --format="%a" /etc/issue 2>/dev/null);if [ "$a" == "root:root" ];then printf "/etc/issue $a";else printf "/etc/issue $a";fi;if (( (0$b&0133)!=0 ));then printf " $b";else printf " $b";fi'''
    tmp_vars["systemvalue2"] = ""
    tmp_vars["checkresult3"] = "failed"
    tmp_vars["scancommand3"] = '''a=$(stat -L --format="%U:%G" /etc/issue.net 2>/dev/null);b=$(stat -L --format="%a" /etc/issue.net 2>/dev/null);if [ "$a" == "root:root" ];then printf "/etc/issue.net $a";else printf "/etc/issue.net $a";fi;if (( (0$b&0133)!=0 ));then printf " $b";else printf " $b";fi'''
    tmp_vars["systemvalue3"] = ""
    tmp_vars["checkresult4"] = "failed"
    tmp_vars["scancommand4"] = '''egrep '(\\\\v|\\\\r|\\\\m|\\\\s)' /etc/issue | grep -v '\\s*#' '''
    tmp_vars["systemvalue4"] = ""
    tmp_vars["checkresult5"] = "failed"
    tmp_vars["scancommand5"] = '''egrep '(\\\\v|\\\\r|\\\\m|\\\\s)' /etc/issue.net | grep -v '\\s*#' '''
    tmp_vars["systemvalue5"] = ""
    tmp_vars["checkresult6"] = "failed"
    tmp_vars["scancommand6"] = '''egrep '(\\\\v|\\\\r|\\\\m|\\\\s)' /etc/motd | grep -v '\\s*#' '''
    tmp_vars["systemvalue6"] = ""
    
    ret_code = 0
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
    arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc2,astdout2,astderr2)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand3"])
    arc3,astdout3,astderr3=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc3,astdout3,astderr3)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand4"])
    arc4,astdout4,astderr4=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc4,astdout4,astderr4)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand5"])
    arc5,astdout5,astderr5=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc5,astdout5,astderr5)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand6"])
    arc6,astdout6,astderr6=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc6,astdout6,astderr6)
    runcontext.sleep()
    
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    match1_found=re.match("^/etc/motd\s*root:root\s*[0-6][0-4][0-4]$",astdout1)
    if match1_found == None:
        tmp_vars["systemvalue1"] = astdout1
    else:
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = astdout1

    if arc2 != 0:
        return (-2, "Failed to invoke module: %s."%astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    astderr2 = resultjson2["stderr"]
    match2_found=re.match("^/etc/issue\s*root:root\s*[0-6][0-4][0-4]$",astdout2)
    if match2_found == None:
        tmp_vars["systemvalue2"] = astdout2
    else:
        tmp_vars["checkresult2"] = "pass"
        tmp_vars["systemvalue2"] = astdout2

    if arc3 != 0:
        return (-2, "Failed to invoke module: %s."%astdout3)
    resultjson3 = json.loads(astdout3)
    astdout3 = resultjson3["stdout"]
    astderr3 = resultjson3["stderr"]
    match3_found=re.match("^/etc/issue.net\s*root:root\s*[0-6][0-4][0-4]$",astdout3)
    if match3_found == None:
        tmp_vars["systemvalue3"] = astdout3
    else:
        tmp_vars["checkresult3"] = "pass"
        tmp_vars["systemvalue3"] = astdout3

    if arc4 != 0:
        return (-2, "Failed to invoke module: %s."%astdout4)
    resultjson4 = json.loads(astdout4)
    astdout4 = resultjson4["stdout"]
    astderr4 = resultjson4["stderr"]
    match4_found=re.match("^$",astdout4)
    if match4_found == None:
        tmp_vars["systemvalue4"] = astdout4
    else:
        tmp_vars["checkresult4"] = "pass"
        tmp_vars["systemvalue4"] = astdout4

    if arc5 != 0:
        return (-2, "Failed to invoke module: %s."%astdout5)
    resultjson5 = json.loads(astdout5)
    astdout5 = resultjson5["stdout"]
    astderr5 = resultjson5["stderr"]
    match5_found=re.match("^$",astdout5)
    if match5_found == None:
        tmp_vars["systemvalue5"] = astdout5
    else:
        tmp_vars["checkresult5"] = "pass"
        tmp_vars["systemvalue5"] = astdout5
    
    if arc6 != 0:
        return (-2, "Failed to invoke module: %s."%astdout6)
    resultjson6 = json.loads(astdout6)
    astdout6 = resultjson6["stdout"]
    astderr6 = resultjson6["stderr"]
    match6_found=re.match("^$",astdout6)
    if match6_found == None:
        tmp_vars["systemvalue6"] = astdout6
    else:
        tmp_vars["checkresult6"] = "pass"
        tmp_vars["systemvalue6"] = astdout6

    if tmp_vars["checkresult1"]=="pass" and tmp_vars["checkresult2"]=="pass" and tmp_vars["checkresult3"]=="pass" and tmp_vars["checkresult4"]=="pass" and tmp_vars["checkresult5"]=="pass" and tmp_vars["checkresult6"]=="pass":
        tmp_vars["policyresult"]="pass"
        ret_code = 0
    else:
        ret_code = -1

    rc,out=curtemplate.render(runcontext.get_template_file('t_2_3_5.j2'),**tmp_vars)
    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
