﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.4','2.4.3']

def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out
def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = ""
    tmp_vars["systemvalue1"] = ""
    
    checks = []
    checks.append(["egrep \"^\\s*\\*\\s+hard\\s+core\\s+0\\s*\" /etc/security/limits.conf 2>/dev/null", ".+"])
    checks.append(["egrep \"^\\s*\\*\\s+hard\\s+core\\s+0\\s*\" /etc/security/limits.d/* 2>/dev/null", ".+"])
    checks.append(["sysctl fs.suid_dumpable", "^\\s*fs\\.suid_dumpable\\s*=\\s*0\\s*$"])

    isAllTrue = "true"
    isOrin = "false"
    index = 1
    Msg = []

    for check in checks:
        tmp_vars["scancommand1"] = check[0]
        runcontext.set_mod_params_instance(ansible_params,"command",check[0])
        arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
        runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
        runcontext.sleep()

        if arc1 != 0:
            return (-2, "Failed to invoke module: %s."%astdout1)
        resultjson1 = json.loads(astdout1)
        astdout1 = resultjson1["stdout"]
        astderr1 = resultjson1["stderr"]
        match1_found=re.match(check[1],astdout1)
        
        if match1_found == None:
            if index == 3:
                tmp_vars["systemvalue1"] = astdout1 
                isAllTrue = "false"
        else:
            if index == 3:
                Msg.append(astdout1)
            else:
                Msg.append(astdout1 + " and ")
            if index == 1 or index == 2:
                isOrin = "true"

        index += 1

    if isAllTrue == "true" and isOrin == "true":
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = ''.join(Msg)
    else:
        tmp_vars["systemvalue1"] = astdout1

    if tmp_vars["checkresult1"]=="pass":
        tmp_vars["policyresult"]="pass"
        ret_code = 0
    else:
        ret_code = -1

    rc,out=curtemplate.render(runcontext.get_template_file('t_2_4_3.j2'),**tmp_vars)
    if rc == False:
        return (-2,"Failed to render template.%s" % out)
        
    return ret_code,out
