﻿# -*- coding: UTF-8 -*-
import re
import json


def get_tags():
    return ['2', '2.6', '2.6.1']


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)

    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    ret_code = -1
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"

    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = r'''df --local -P | awk {'if (NR!=1) print $6'} | xargs -I '[]' find '[]' -xdev  -type f \( -perm -04000 -o -perm -02000 \) -exec ls -lg {} \; 2>/dev/null | egrep -v "(/usr/bin/at|/usr/bin/umount|/usr/bin/pkexec|/usr/bin/su|/usr/bin/mount|/usr/bin/chfn|/usr/bin/well|/usr/bin/chage|/usr/bin/chsh|/usr/bin/fusermount|/usr/bin/sudo|/usr/bin/ssh-agent|/usr/bin/passwd|/usr/bin/write|/usr/bin/crontab|/usr/bin/newgrp|/usr/bin/Xorg|/usr/bin/gpasswd|/usr/bin/staprun|/usr/bin/locate|/usr/sbin/lockdev|/usr/sbin/usernetctl|/usr/sbin/userhelper|/usr/sbin/mount.nfc|/usr/sbin/unix_chkpwd|/usr/sbin/netreport|/usr/sbin/pam_timestamp_check|/usr/lib/polkit-l/polkit-agent-helper-l|/usr/libexec/dbus-l/dbus-daemon-launch-helper|/usr/libexec/utempter/utempter|/usr/libexec/abrt-action-install-debuginfo-to-abrt-cache|/usr/libexec/spice-gtk-x86_64/spice-client-glib-usb-acl-helper|/usr/libexec/qemu-bridge-helper}|/uer/libexec/openssh/ssh-keysign|/usr/lib64/vte-2.91/gnome-pty-helper)$" '''
    tmp_vars["systemvalue1"] = ""

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    match1 = re.match(r"^\s*$", astdout1)

    tmp_vars["systemvalue1"] = astdout1
    if match1:
        tmp_vars["checkresult1"] = "pass"

    if tmp_vars["checkresult1"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('t_2_6_1.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
