﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['3','3.1','3.1.1']

def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out
def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = r'''retFalse='';retTrue='';total=false;lists=$(grep -i "\bauth\b" /etc/rsyslog.conf | grep  -v "^\s*#" | awk '{print $1}');for list in $lists;do out=$(echo $list | awk '{gsub(";","\n"); print}');if [ "$total" == false ] ;then for ot in $out;do out=$(echo "$ot" | grep -i "\bauth\b");out2=$(echo "$ot" | grep -i "\bnone\b");if [ ! -z "$out" ];then if [ ! -z "$out2" ];then total=false;retFasle=$ot;else total=true;retTrue=$ot;fi;fi;done;fi;done;echo "$total $retFalse $retTrue"'''
    tmp_vars["systemvalue1"] = ""
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = r'''retFalse='';retTrue='';total=false;lists=$(grep -i "\bauthpriv\b" /etc/rsyslog.conf | grep  -v "^\s*#" | awk '{print $1}');for list in $lists;do out=$(echo $list | awk '{gsub(";","\n"); print}');if [ "$total" == false ] ;then for ot in $out;do out=$(echo "$ot" | grep -i "\bauthpriv\b");out2=$(echo "$ot" | grep -i "\bnone\b");if [ ! -z "$out" ];then if [ ! -z "$out2" ];then total=false;retFasle=$ot;else total=true;retTrue=$ot;fi;fi;done;fi;done;echo "$total $retFalse $retTrue"'''
    tmp_vars["systemvalue2"] = ""

    ret_code = 0
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
    arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc2,astdout2,astderr2)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    match1_found = re.match(r"true.+",astdout1)
    L = astdout1.split(' ')
    tmp_vars["systemvalue1"] = L[1]
    if match1_found != None:
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = L[2]
        
    if arc2 != 0:
        return (-2, "Failed to invoke module: %s."%astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    match2_found = re.match(r"true.+",astdout2)
    
    L = astdout2.split(' ')
    tmp_vars["systemvalue2"] = L[1]
    if match2_found != None:
        tmp_vars["checkresult2"] = "pass"
        tmp_vars["systemvalue2"] = L[2]

    ret_code = -1
    if tmp_vars["checkresult1"]=="pass" and tmp_vars["checkresult2"]=="pass":
        tmp_vars["policyresult"]="pass"
        ret_code = 0
        
    rc,out=curtemplate.render(runcontext.get_template_file('t_3_1_1.j2'),**tmp_vars)
    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
