﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['3','3.1','3.1.8']

def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out
def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"

    tmp_vars["systemvalue1"] = ""
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = r'''retFalse='';retTrue='';total=false;lists=$(grep -i "\bauth\b" /etc/rsyslog.conf | grep  -v "^\s*#" | awk '{print $1}');for list in $lists;do out=$(echo $list | awk '{gsub(";","\n"); print}');if [ "$total" == false ] ;then for ot in $out;do out=$(echo "$ot" | grep -i "\bauth\b");out2=$(echo "$ot" | grep -i "\bnone\b");if [ ! -z "$out" ];then if [ ! -z "$out2" ];then total=false;retFalse=$ot;else total=true;retTrue=$ot;fi;fi;done;fi;done;echo "$total $retFalse $retTrue" '''

    tmp_vars["systemvalue2"] = ""
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = r'''retFalse='';retTrue='';total=false;lists=$(grep -i "\bmail\b" /etc/rsyslog.conf | grep  -v "^\s*#" | awk '{print $1}');for list in $lists;do out=$(echo $list | awk '{gsub(";","\n"); print}');if [ "$total" == false ] ;then for ot in $out;do out=$(echo "$ot" | grep -i "\bmail\b");out2=$(echo "$ot" | grep -i "\bnone\b");if [ ! -z "$out" ];then if [ ! -z "$out2" ];then total=false;retFalse=$ot;else total=true;retTrue=$ot;fi;fi;done;fi;done;echo "$total $retFalse $retTrue" '''

    tmp_vars["systemvalue3"] = ""
    tmp_vars["checkresult3"] = "failed"
    tmp_vars["scancommand3"] = r''' authf=$(grep -i "auth\.\*" /etc/rsyslog.conf | grep  -v "^\s*#" | awk '{print $2}');if [[ "$authf" =~ ^- ]];then authf=${authf:1};fi;if [ -f "$authf" ];then for auth in $authf;do if [[ "$auth" =~ ^- ]];then auth=${auth:1};fi;ass=$(stat -L --format="%a" $auth 2>/dev/null);aout=$(stat -L --format="%U:%G" $auth 2>/dev/null);if (( (0"$ass"&0177) != 0));then echo "$auth $ass";fi;if [ "$aout" != "root:root" ];then echo "$auth $aout";fi;done;else echo "auth's configuration file does not exist";fi '''

    tmp_vars["systemvalue4"] = ""
    tmp_vars["checkresult4"] = "failed"
    tmp_vars["scancommand4"] = r''' mailf=$(grep -i "mail\.\*" /etc/rsyslog.conf | grep  -v "^\s*#" | awk '{print $2}');if [[ "$mailf" =~ ^- ]];then mailf=${mailf:1};fi;if [ -f "$mailf" ];then for mail in $mailf;do if [[ "$mail" =~ ^- ]];then mail=${mail:1};fi;mss=$(stat -L --format="%a" $mail 2>/dev/null);mout=$(stat -L --format="%U:%G" $mail 2>/dev/null);if (( (0"$mss"&0177) != 0));then echo "$mail $mss";fi;if [ "$mout" != "root:root" ];then echo "$mail $mout";fi;done;else echo "mail's configuration file does not exist";fi '''

    ret_code = 0
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
    arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc2,astdout2,astderr2)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand3"])
    arc3,astdout3,astderr3=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc3,astdout3,astderr3)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand4"])
    arc4,astdout4,astderr4=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc4,astdout4,astderr4)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    match1_found=re.match("true.*",astdout1)
    L = astdout1.split(' ')
    tmp_vars["systemvalue1"] = L[1]
    if match1_found != None:
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = L[2]

    if arc2 != 0:
        return (-2, "Failed to invoke module: %s."%astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    astderr2 = resultjson2["stderr"]
    match2_found=re.match("true.*",astdout2)
    L=astdout2.split(' ')
    tmp_vars["systemvalue2"] = L[1]
    if match2_found != None:
        tmp_vars["checkresult2"] = "pass"
        tmp_vars["systemvalue2"] = L[2]

    if arc3 != 0:
        return (-2, "Failed to invoke module: %s."%astdout3)
    resultjson3 = json.loads(astdout3)
    astdout3 = resultjson3["stdout"]
    astderr3 = resultjson3["stderr"]
    match3_found=re.match("^$",astdout3)

    if match3_found != None:
        tmp_vars["checkresult3"] = "pass"
        tmp_vars["systemvalue3"] = astdout3
    else:
        tmp_vars["systemvalue3"] = astdout3

    if arc4 != 0:
        return (-2, "Failed to invoke module: %s."%astdout4)
    resultjson4 = json.loads(astdout4)
    astdout4 = resultjson4["stdout"]
    astderr4 = resultjson4["stderr"]
    match4_found=re.match("^$",astdout4)

    if match4_found != None:
        tmp_vars["checkresult4"] = "pass"
        tmp_vars["systemvalue4"] = astdout4
    else:
        tmp_vars["systemvalue4"] = astdout4

    if tmp_vars["checkresult1"]=="pass" and tmp_vars["checkresult2"]=="pass" and tmp_vars["checkresult3"]=="pass" and tmp_vars["checkresult4"]=="pass":
        tmp_vars["policyresult"]="pass"
        ret_code = 0
    else:
        ret_code = -1
    rc,out=curtemplate.render(runcontext.get_template_file('t_3_1_8.j2'),**tmp_vars)
    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
